<template>
  <q-page class="flex">
    <div class="doc-container col-12">
      <div class="minheight-rows gutter-md">
        <div class="row title-row items-center">
          <i class="fas fa-th-large"></i>
          <div class="page-title">{{ $t('playlist.add') }}</div>
        </div>
        <div class="row justify-center">
          <div class="col-8 form">
            <div class="row">
              <div class="col-12">
            <q-field>
              <q-input :float-label="$t('Title')"
                       v-model="title"
                       max-length="50"
              />
            </q-field>
            <q-field>
              <!-- Binds to parent QSearch -->
              <q-chips-input
                      v-model="applications"
                      :placeholder="$t('Search')"
                      @add="appAdded"
                      :float-label="$t('Applications')"
              ><q-autocomplete @search="searchApplication"/>
              </q-chips-input>
            </q-field>
            <q-field>
              <q-list>
                <q-list-header>{{ $t('content.contents') }}</q-list-header>
                <q-item v-for="a in contents" v-bind:key="contentLabel(a)">
                  <q-item-main :label="contentLabel(a)" />
                  <q-item-side right>
                    <q-btn icon="delete" color="negative" size="small" @click="deleteContent(a)"/>
                  </q-item-side>
                </q-item>
                <q-item v-if="!contents.length"
                        class="no-content"
                >
                  <q-item-main :label="$t('content.no_contents')" />
                </q-item>
              </q-list>
              <q-btn :label="$t('content.add')" color="primary" @click="displaySelector" class="float-right margin-top-20" rounded/>
            </q-field>

            <q-field>
              <q-list>
                <q-list-header>{{ $t('direct_links.links') }}</q-list-header>
                <q-item v-for="(dl, index) in direct_links" :key="index">
                  <q-item-main :label="directLinkLabel(dl)" />
                  <q-item-side right>

                    <q-card-actions class="justify-end">
                        <q-btn-dropdown outline rounded class="action-btn full-width" :label="$t('More')">
                            <q-list link style="min-width: 100px">
                              <q-item
                                v-close-overlay
                                @click.native="editLink(dl, dl.index || index)">{{ $t('Edit') }}</q-item>
                              <q-item
                                v-close-overlay
                                @click.native="(canAddLinkIcon) ? openPreview(dl, dl.index || index) : false"
                                :disabled="!canAddLinkIcon">{{ $t('direct_links.preview_card') }}</q-item>
                              <q-item
                                v-close-overlay
                                @click.native="(canAddLinkIcon) ? uploadDirectLinkIcon(dl, dl.index || index) : false"
                                :disabled="!canAddLinkIcon">{{ $t('direct_links.set_thumbnail') }}</q-item>
                              <q-item
                                v-close-overlay
                                @click.native="deleteDirectLink(dl, dl.index || index)">{{ $t('state.Delete') }}</q-item>
                            </q-list>
                        </q-btn-dropdown>
                    </q-card-actions>
                  </q-item-side>
                </q-item>
                <q-item v-if="!direct_links.length" class="no-content">
                  <q-item-main :label="$t('direct_links.no_links')" />
                </q-item>
              </q-list>
              <q-btn :label="$t('direct_links.add')" color="primary" @click="addNewLink" class="float-right margin-top-20" rounded/>
            </q-field>

            <q-field v-if="isAdmin">
              <q-checkbox :label="$t('Pinned')" v-model="pinned" />
              <div class="checkbox-sub-label">{{ $t('playlist.about_pin') }}</div>
            </q-field>
          </div>
            </div>
            <div class="q-card-separator"></div>
            <div class="row reverse margin-top-20">
              <div class="col-12">
                <div class="row justify-end">
                  <q-btn :label="$t('Cancel')" color="primary" @click.native="cancel" flat rounded/>
                  <q-btn :label="isEditing ? $t('Save') : $t('playlist.add')" @click="save" class="action-btn" outline rounded />
                </div>
              </div>
            </div>
          </div>
        </div>
      </div>
      <AddLinkDialog :ok="recordLink" :cancel="cancelLinkAddition" :displayed="linksDialogDisplayed" ref="linkdialog" />
      <ApplicationContentSelector :ok="addContent" :cancel="cancelContentAdd" :displayed="selectorDisplayed"/>

      <q-dialog v-model="previewDialogDisplayed" @ok="exitPreview">
        <div slot="body">
          <ApplicationCard :application="getApplicationStub()" @click="openLinkFromPreview" />
        </div>
      </q-dialog>

      <q-dialog v-model="uploadDialogDisplayed" :ok=false>
        <span slot="title" class="row items-center">
          <div class="text-h6">{{ $t('direct_links.set_thumbnail') }}</div>
          <q-btn icon="close" flat round dense size="sm" @click.native="closeUpload()"/>
        </span>
        <div slot="body">
          <q-uploader ref="q_uploader" :url="linkIconUrl" send-raw method="PUT"
          :upload-factory="uploadFile" max-file-size="500000" @uploaded="uploadSuceeded" @fail="uploadFailed" auto-expand />
        </div>
      </q-dialog>
    </div>
  </q-page>
</template>

<style>
</style>

<script>
import {mapActions, mapState} from 'vuex'
import _ from 'lodash'
import ApplicationContentSelector from '../../components/application_content_selector'
import AddLinkDialog from '../../components/link_addition_dialog'
import ApplicationCard from '../../components/application_card'

export default {
  name: 'Playlists',
  data: () => ({
    title: '',
    pinned: false,
    applications: [],
    contents: [],
    user: {},
    selectorDisplayed: false,
    loadedPlaylistIndex: null,
    direct_links: [],
    linksDialogDisplayed: false,
    uploadDialogDisplayed: false,
    previewDialogDisplayed: false,
    linkIconUrl: '',
    indexOfLinkIconUploading: null,
    canAddLinkIcon: false,
    iconIndexesToDelete: [],
    isEditing: false
  }),
  methods: {
    ...mapActions({
      listInstalledApps: 'applications/listInstalledApps'
    }),

    ...mapActions('playlists', ['savePlaylist', 'loadPlaylistToEdit', 'getPlaylistLinkIconUrl', 'deletePlaylistIcon', 'setDirectLinkIcon']),

    save: async function () {
      let user

      if (this.current_playlist.id) {
        user = this.current_playlist.user
      } else {
        user = {
          url: this.current_user.url
        }
      }

      if (this.current_playlist.id && this.iconIndexesToDelete.length) {
        // user deleted those links so we need to clear their icons
        this.iconIndexesToDelete.forEach(async (index) => {
          await this.deletePlaylistIcon({playlistId: this.current_playlist.id, directLinkIndex: index})
        })
      }

      await this.savePlaylist({
        loadedPlaylistIndex: this.loadedPlaylistIndex,
        title: this.title,
        pinned: this.pinned,
        user: user,
        applications: this.applications,
        contents: this.contents,
        directLinks: this.direct_links
      })
      this.$router.push('/playlists')
    },

    searchTerm: function (term, done) {
      let searched = term.toLowerCase()
      setTimeout(() => {
        let filtered = _.filter(this.terms, t => {
          return t.value.toLowerCase().includes(searched)
        })

        done(filtered)
      })
    },

    searchApplication: function (app, done) {
      let searched = app.toLowerCase()
      setTimeout(() => {
        let filtered = _.filter(this.application_list, t => {
          return t.label.toLowerCase().includes(searched)
        })

        done(filtered)
      })
    },

    appAdded: function (newValue, event) {
      let bundle = newValue.val

      let existingApp = _.find(this.application_list, a => a.value === bundle)

      if (!existingApp) {
        this.$q.notify(this.$t('application.select_existing'))
        // remove just added application from the list
        setTimeout(() => {
          this.applications = _.filter(this.applications, a => a !== bundle)
        }, 1)
      }
    },

    displaySelector: function (bundle, contentId) {
      this.selectorDisplayed = true
    },

    addNewLink: function () {
      this.$refs.linkdialog.reset(null)
      this.linksDialogDisplayed = true
    },

    addContent: function (bundle, contentId) {
      if (!this.contents) {
        this.contents = []
      }

      if (!_.find(this.contents, c => c.bundle === bundle && c.content_id === contentId)) {
        this.contents.push({
          bundle: bundle,
          content_id: contentId
        })
        this.selectorDisplayed = false
      } else {
        this.$q.notify(this.$t('playlist.content_exist'))
      }
    },

    recordLink: function (href, title, index) {
      if (!this.direct_links) {
        this.direct_links = []
      }
      // add a new link
      if (index === null) {
        index = Math.max(0, ...this.direct_links.map((e) => e.index)) + 1
        if (!_.find(this.direct_links, l => l.href === href && l.title === title)) {
          this.direct_links.push({
            href: href,
            title: title,
            index: index
          })
        } else {
          this.$q.notify(this.$t('playlist.link_exist'))
        }
      } else {
        // updating existing link
        let arrayIndex = _.findIndex(this.direct_links, l => l.index === index)
        if (arrayIndex < 0) {
          this.$q.notify(this.$t('Error'))
        }
        this.direct_links[arrayIndex] = {href: href, title: title, index: index}
      }
      this.linksDialogDisplayed = false
    },

    editLink: function (link, index) {
      this.$refs.linkdialog.reset({href: link.href, title: link.title, index: index})
      this.linksDialogDisplayed = true
    },

    cancelContentAdd: function () {
      this.selectorDisplayed = false
    },

    cancelLinkAddition: function () {
      this.linksDialogDisplayed = false
    },

    contentLabel: (c) => c.bundle + '-' + c.content_id,

    directLinkLabel: (l) => `${l.title} (${new URL(l.href).host})`,

    deleteContent: function (content) {
      this.contents = this.contents.filter(c => c.bundle !== content.bundle || c.content_id !== content.content_id)
    },

    deleteDirectLink: function (link, index) {
      this.direct_links = this.direct_links.filter(l => l.href !== link.href || l.title !== link.title)
      this.iconIndexesToDelete.push(index)
    },

    loadPlaylist: function (playlistIndex) {
      this.loadPlaylistToEdit({playlistIndex: parseInt(playlistIndex)})
    },

    async uploadDirectLinkIcon (link, index) {
      this.indexOfLinkIconUploading = index
      this.linkIconUrl = await this.getPlaylistLinkIconUrl({playlistId: this.current_playlist.id, directLinkIndex: index})
      this.uploadDialogDisplayed = true
    },
    closeUpload: function () {
      this.indexOfLinkIconUploading = null
      this.uploadDialogDisplayed = false
      this.$refs.q_uploader.reset()
    },
    uploadFile: function (file, updateProgress) {
      let promise = this.setDirectLinkIcon({playlistId: this.current_playlist.id, directLinkIndex: this.indexOfLinkIconUploading, file: file, progress: updateProgress})

      return promise
    },
    uploadSuceeded: function () {
      if (this.iconIndexesToDelete.indexOf(this.indexOfLinkIconUploading) !== -1) {
        // this link index was earlier removed, we planned on removing icon
        // mark it off deletion
        this.iconIndexesToDelete = this.iconIndexesToDelete.filter(e => e !== this.indexOfLinkIconUploading)
      }
      this.closeUpload()
    },
    uploadFailed: function () {
      this.$q.notify('Upload failed. Is file too big ?')
      this.closeUpload()
    },

    // preview-related
    async openPreview (link, index) {
      this.indexOfLinkIconUploading = index
      this.linkIconUrl = await this.getPlaylistLinkIconUrl({playlistId: this.current_playlist.id, directLinkIndex: index})
      this.previewDialogDisplayed = true
    },
    exitPreview (e) {
      this.indexOfLinkIconUploading = null
      this.linkIconUrl = ''
    },
    getApplicationStub () {
      // fake application to feed ApplicationCard with for preview
      let link = _.find(this.direct_links, a => a.index === this.indexOfLinkIconUploading)
      if (!link) {
        return {name: '', picture: ''}
      }
      // adding timestamp to avoid browser cache
      return {name: link.title, picture: this.linkIconUrl + '?t=' + new Date().getTime()}
    },
    openLinkFromPreview () {
      let link = _.find(this.direct_links, a => a.index === this.indexOfLinkIconUploading)
      if (link) {
        window.open(link.href, '_blank')
      }
    }
  },
  computed: mapState({
    application_list: (state) => state.applications.installed_applications.map(a => {
      return {
        label: a.name,
        value: a.bundle
      }
    }),
    cancel: function () {
      this.$router.push('/playlists')
    },
    playlists: (state) => state.playlists.categories,

    current_playlist: (state) => state.playlists.edited_playlist,

    current_user: (state) => _.get(state, 'oidc.user'),

    isAdmin: (state) => {
      let role = _.get(state, 'oidc.user.roles', false)

      if (!role) {
        return false
      }

      if (role === 'admin' || role.includes('admin')) {
        return true
      }

      return false
    }
  }),

  mounted: function () {
    this.listInstalledApps()

    this.loadedPlaylistIndex = this.$route.params.playlistIndex

    if (this.loadedPlaylistIndex) {
      this.isEditing = true
      this.loadPlaylist(this.loadedPlaylistIndex)
    } else {
      this.isEditing = false
    }
  },
  watch: {
    current_playlist: function (val) {
      if (this.loadedPlaylistIndex) {
        this.title = this.current_playlist.title
        this.pinned = this.current_playlist.pinned ? this.current_playlist.pinned : false
        this.applications = this.current_playlist.applications ? this.current_playlist.applications : []
        this.contents = this.current_playlist.contents ? this.current_playlist.contents : []
        this.direct_links = this.current_playlist.direct_links ? this.current_playlist.direct_links : []
        this.canAddLinkIcon = this.current_playlist && this.current_playlist.id
      }
    }
  },
  components: {
    'ApplicationContentSelector': ApplicationContentSelector,
    'AddLinkDialog': AddLinkDialog,
    'ApplicationCard': ApplicationCard
  }
}
</script>
